Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.statsvn.util
Interface ISvnInfoProcessor

All Known Implementing Classes:
  SvnInfoUtils, SvnKitInfo

    public interface ISvnInfoProcessor

Performs svn info queries.

Author:
  jkealey

Method Summary
`String` | `absolutePathToUrl(String absolute)` Converts an absolute path in the repository to a URL, using the repository URL
`String` | `absoluteToRelativePath(String absolute)` Converts an absolute path in the repository to a path relative to the working folder root.
`void` | `addDirectory(String relativePath)` Adds a directory to the list of known directories.
`void` | `checkRepoRootAvailable()` Verifies that the "svn info" command can return the repository root (info available in svn >= 1.3.0)
`boolean` | `existsInWorkingCopy(String relativePath)` Returns true if the file exists in the working copy (according to the svn metadata, and not file system checks).
`String` | `getModuleName()` Assumes #loadInfo(String) has been called.
`String` | `getRepositoryUrl()` Assumes #loadInfo() has been invoked.
`String` | `getRepositoryUuid()` Assumes #loadInfo() has been invoked.
`String` | `getRevisionNumber(String relativePath)` Returns the revision number of the file in the working copy.
`String` | `getRootRevisionNumber()` Assumes #loadInfo() has been invoked.
`String` | `getRootUrl()` Assumes #loadInfo() has been invoked.
`boolean` | `isDirectory(String relativePath)` Returns true if the path has been identified as a directory.
`void` | `loadInfo()` Initializes our representation of the repository.
`void` | `loadInfo(InputStream stream)` Loads the information from svn info if needed.
`String` | `relativePathToUrl(String relative)` Converts a relative path in the working folder to a URL, using the working folder's root URL
`String` | `relativeToAbsolutePath(String relative)` Converts a relative path in the working folder to an absolute path in the repository.
`String` | `urlToAbsolutePath(String url)` Converts a url to an absolute path in the repository.
`String` | `urlToRelativePath(String url)` Converts a url to a relative path in the repository.

Method Detail

### absoluteToRelativePath

    String absoluteToRelativePath(String absolute)

  Converts an absolute path in the repository to a path relative to the working folder root. Will return null if absolute path does not start with getModuleName();

  Parameters:
    `absolute` - Example (assume getModuleName() returns /trunk/statsvn) /trunk/statsvn/package.html
  Returns:
    Example: package.html

### absolutePathToUrl

    String absolutePathToUrl(String absolute)

  Converts an absolute path in the repository to a URL, using the repository URL

  Parameters:
    `absolute` - Example: /trunk/statsvn/package.html
  Returns:
    Example: svn://svn.statsvn.org/statsvn/trunk/statsvn/package.html

### relativePathToUrl

    String relativePathToUrl(String relative)

  Converts a relative path in the working folder to a URL, using the working folder's root URL

  Parameters:
    `relative` - Example: src/Messages.java
  Returns:
    Example: svn://svn.statsvn.org/statsvn/trunk/statsvn/src/Messages.java

### relativeToAbsolutePath

    String relativeToAbsolutePath(String relative)

  Converts a relative path in the working folder to an absolute path in the repository.

  Parameters:
    `relative` - Example: src/Messages.java
  Returns:
    Example: /trunk/statsvn/src/Messages.java

### existsInWorkingCopy

    boolean existsInWorkingCopy(String relativePath)

  Returns true if the file exists in the working copy (according to the svn metadata, and not file system checks).

  Parameters:
    `relativePath` - the path
  Returns:
    `true` if it exists

### getModuleName

    String getModuleName()

  Assumes #loadInfo(String) has been called. Never ends with /, might be empty.

  Returns:
    The absolute path of the root of the working folder in the repository.

### getRevisionNumber

    String getRevisionNumber(String relativePath)

  Returns the revision number of the file in the working copy.

  Parameters:
    `relativePath` - the filename
  Returns:
    the revision number if it exists in the working copy, null otherwise.

### getRootRevisionNumber

    String getRootRevisionNumber()

  Assumes #loadInfo() has been invoked.

  Returns:
    the root of the working folder's revision number (last checked out revision number)

### getRootUrl

    String getRootUrl()

  Assumes #loadInfo() has been invoked.

  Returns:
    the root of the working folder's url (example: svn://svn.statsvn.org/statsvn/trunk/statsvn)

### getRepositoryUuid

    String getRepositoryUuid()

  Assumes #loadInfo() has been invoked.

  Returns:
    the uuid of the repository

### getRepositoryUrl

    String getRepositoryUrl()

  Assumes #loadInfo() has been invoked.

  Returns:
    the repository url (example: svn://svn.statsvn.org/statsvn)

### isDirectory

    boolean isDirectory(String relativePath)

  Returns true if the path has been identified as a directory.

  Parameters:
    `relativePath` - the path
  Returns:
    true if it is a known directory.

### addDirectory

    void addDirectory(String relativePath)

  Adds a directory to the list of known directories. Used when inferring implicit actions on deleted paths.

  Parameters:
    `relativePath` - the relative path.

### loadInfo

    void loadInfo(InputStream stream)
                  throws net.sf.statcvs.input.LogSyntaxException,
                         IOException

  Loads the information from svn info if needed.

  Parameters:
    `stream` - the input stream representing an svn info command.
  Throws:
    `net.sf.statcvs.input.LogSyntaxException` - if the format of the svn info is invalid
    `IOException` - if we can't read from the response stream.

### loadInfo

    void loadInfo()
                  throws net.sf.statcvs.input.LogSyntaxException,
                         IOException

  Initializes our representation of the repository.

  Throws:
    `net.sf.statcvs.input.LogSyntaxException` - if the svn info --xml is malformed
    `IOException` - if there is an error reading from the stream

### urlToAbsolutePath

    String urlToAbsolutePath(String url)

  Converts a url to an absolute path in the repository.

  Parameters:
    `url` - Examples: svn://svn.statsvn.org/statsvn/trunk/statsvn, svn://svn.statsvn.org/statsvn/trunk/statsvn/package.html
  Returns:
    Example: /trunk/statsvn, /trunk/statsvn/package.html

### urlToRelativePath

    String urlToRelativePath(String url)

  Converts a url to a relative path in the repository.

  Parameters:
    `url` - Examples: svn://svn.statsvn.org/statsvn/trunk/statsvn, svn://svn.statsvn.org/statsvn/trunk/statsvn/package.html
  Returns:
    Example: ".", package.html

### checkRepoRootAvailable

    void checkRepoRootAvailable()
                                throws SvnVersionMismatchException

  Verifies that the "svn info" command can return the repository root (info available in svn >= 1.3.0)

  Throws:
    `SvnVersionMismatchException` - if `svn info` failed to provide a non-empty repository root

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD